package jp.sourceforge.sgerrard.action;

import java.io.IOException;
import java.io.OutputStream;
import java.util.List;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import jp.sourceforge.sgerrard.entity.Prefecture;
import jp.sourceforge.sgerrard.form.PrefectureForm;
import jp.sourceforge.sgerrard.service.PrefectureService;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

public class PrefectureAction {

  @Resource
  private HttpServletResponse response;

  @Resource
  private PrefectureService prefectureService;

  @ActionForm
  @Resource
  private PrefectureForm prefectureForm;

  @Execute(validator = false)
  public String index() throws IOException {

    List<Prefecture> prefs = this.prefectureService.findByHeader(StringUtils
        .upperCase(this.prefectureForm.q));
    OutputStream os = response.getOutputStream();

    for (Prefecture p : prefs) {
      IOUtils.write(p.prefecture + "\n", os);
    }

    os.flush();

    return null;

  }

}
